package jogo;

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Random;

public class ServidorThread extends Thread {

    private Socket conexao;
    private ArrayList<ObjectOutputStream> outrosClientes;
    private ArrayList<Jogador> jogadores = new ArrayList<Jogador>();
    private Random Semantealeatoria = new Random();
    //private ObjectOutputStream[] saidaDosClientes;
    private String mensagemenviada;
    private Mensagem msgout;
    private Mensagem msgin;
    private int cod;
    private Boolean J1;
    private Boolean J2;
    int rodadaAtual;
    private String body;
    private Boolean nomeRecebido = false;
    //private ArrayList<String> baralho = new ArrayList<String>();
    private String cartas;
    private String manilha;
    private Boolean Embaralhar;
    //private ObjectOutputStream jogadorAtual;
    private ObjectOutputStream jogadorAtual;
    private Servidor servidor;

    public ServidorThread(Socket c, ArrayList<ObjectOutputStream> saidaDosClientes, ArrayList<Jogador> jj, Servidor s) {
        this.conexao = c;
        this.jogadores = jj;
        //this.baralho = bb;
        //this.manilha = me ;
        //this.rodadaAtual = rd;
        //this.saidaDosClientes =  new ObjectOutputStream[2];
        this.outrosClientes = saidaDosClientes;
        this.servidor = s;
        this.jogadorAtual = servidor.jogadorAtual;
        //this.servidor = servidor;
        //this.Embaralhar = Embaralhar;
        //this.jogadorAtual = jogadorAtual;
    }

    public void run() {
        ObjectOutputStream saida;
        ObjectInputStream entrada;

        try {
            //obtendo os fluxos de entrada e de saida
            saida = new ObjectOutputStream(conexao.getOutputStream());
            entrada = new ObjectInputStream(conexao.getInputStream());

            if (this.outrosClientes.size() == 0) {
                servidor.jogadorAtual = saida;
            }

            //adicionando o fluxo de saida deste cliente no ArrayList compartilhado por todas as threads
            this.outrosClientes.add(saida);


            boolean conectado = true;

            // enviando o objeto Pessoa para o cliente
            //saida.writeObject(msgout);
            //System.out.println("Cliente conectou no servidor...");

            msgin = (Mensagem) entrada.readObject();
            cod = Integer.parseInt(msgin.getCodigo());
            body = msgin.getCorpo();

            if (cod == 100) {

                this.jogadores.add(new Jogador(body, 0, saida));

            }

            if (jogadores.size() == 2 && (nomeRecebido == false)) {
                for (ObjectOutputStream saidaCli : outrosClientes) {
                    // evitando enviar a mensagem para o cliente que a originou
                    if (saidaCli != saida) {
                        //Envia solicitação de nome de jogador adversário
                        //System.out.println("Jogador: "+jogadores.get(1).getNome());
                        saidaCli.writeObject(new Mensagem("101", jogadores.get(1).getNome()));
                        saidaCli.flush();
                        saidaCli.reset();
                        nomeRecebido = true;
                    } else {
                        //para enviar para quem a originou
                        saidaCli.writeObject(new Mensagem("101", jogadores.get(0).getNome()));
                        saidaCli.flush();
                        saidaCli.reset();

                    }
                }
            }

            while (conectado) {
                msgin = (Mensagem) entrada.readObject();
                cod = Integer.parseInt(msgin.getCodigo());
                body = msgin.getCorpo();
                // System.out.println("msgin:"+msgin.getCodigo());
                System.out.println("msgin:" + msgin.getCodigo());


                switch (cod) {
                    case 200:   //Mensagem pedindo as cartas
                        if (servidor.Embaralhar) {
                            //Embaralhando as cartas
                            Collections.shuffle(servidor.baralho, this.Semantealeatoria);
                            servidor.manilha = servidor.baralho.get(0);
                            servidor.Embaralhar = false;
                            this.cartas = servidor.baralho.get(1) + servidor.baralho.get(2) + servidor.baralho.get(3) + servidor.manilha;
                            saida.writeObject(new Mensagem("201", cartas));
                        } else {
                            this.cartas = servidor.baralho.get(4) + servidor.baralho.get(5) + servidor.baralho.get(6) + servidor.manilha;
                            saida.writeObject(new Mensagem("201", cartas));
                            servidor.Embaralhar = true;
                        }
                        break;
                    case 300:  //De quem é  mão do jogo?

                        if (servidor.jogadorAtual.equals(saida)) {
                            System.out.println("entrou " + mensagemenviada);
                            //Envia solicitação de nome de jogador adversário
                            saida.writeObject(new Mensagem("301", "true"));
                            saida.flush();


                        } else {
                            //para enviar para quem a originou
                           /* if (servidor.rodadaAtual <= 3) {
                            servidor.rodadaAtual++;
                            }*/

                            saida.writeObject(new Mensagem("301", "false"));
                            saida.flush();
                        }
                        break;
                    case 400: //Recebe as carta da rodada para definir o vencedor
                        for (Jogador j : jogadores) {
                            //Adicionando carta enviada
                            if (j.getSaida().equals(servidor.jogadorAtual) && servidor.CartaJogadorAtual.equals("null")) {

                                servidor.JogadaDecidida =false;
                                //Adicionando carta  do jogador atual
                                j.SetCarta(body);
                                servidor.CartaJogadorAtual = body;
                            }
                            if (!j.getSaida().equals(servidor.jogadorAtual)) {

                                if (j.GetCarta().equals("null") && !body.equals(servidor.CartaJogadorAtual)) {

                                    // Guarda a carta do outro jogador 
                                    j.SetCarta(body);
                                    servidor.jogadorAtual.writeObject(new Mensagem("403", body));
                                } else {
                                    //envia carta do jogador atual para o outro jogador
                                    j.getSaida().writeObject(new Mensagem("402", servidor.CartaJogadorAtual));
                                    saida.flush();
                                }
                            }
                        }

                        break;

                    case 500: //Verifica quem ganhou

                        //Verificando se os dois jogadores já enviaram suas cartas
                        if (!jogadores.get(0).GetCarta().equals("null") && !jogadores.get(1).GetCarta().equals("null")) {

                            //Convertando para inteiro as cartas jogada pelos jogadores
                            int j1 = 0;
                            int j2 = 0;
                            boolean vencedor = false;
                            boolean conv1 = false;
                            boolean conv2 = false;
                            //Traduzindo cartas qjk do jogador 1 
                            if (jogadores.get(0).GetCarta().substring(0, 1).equals("q")) {
                                j1 = 10;
                                conv1 = !conv1;
                            }

                            if (jogadores.get(0).GetCarta().substring(0, 1).equals("j")) {
                                j1 = 11;
                                conv1 = !conv1;
                            }

                            if (jogadores.get(0).GetCarta().substring(0, 1).equals("k")) {
                                j2 = 12;
                                conv1 = !conv1;
                            }

                            if (!conv1) {
                                System.out.println("Carta: " + jogadores.get(0).GetCarta());
                                j1 = Integer.parseInt(jogadores.get(0).GetCarta().substring(0, 1));


                            }


                            //Traduzindo cartas qjk do jogador 1
                            if (jogadores.get(1).GetCarta().substring(0, 1).equals("q")) {
                                j2 = 10;
                                conv2 = !conv2;
                            }

                            if (jogadores.get(1).GetCarta().substring(0, 1).equals("j")) {
                                j2 = 11;
                                conv2 = !conv2;
                            }

                            if (jogadores.get(1).GetCarta().substring(0, 1).equals("k")) {
                                j2 = 12;
                                conv2 = !conv2;
                            }
                            if (!conv2) {
                                System.out.println("Carta: " + jogadores.get(1).GetCarta());
                                j2 = Integer.parseInt(jogadores.get(1).GetCarta().substring(0, 1));
                            }

                            // Pegando o naipe de cada carta jogada
                            int naipeJ1 = 0;
                            int naipeJ2 = 0;
                            //Carta Virada
                            int cartVirada = 0;
                            //Manilha ou coringa
                            int m = 0;

                            /*Abribuindo peso aos Naipes
                            Peso dos naiptes
                             * o = 0
                             * e = 1
                             * c = 2
                             * p = 3
                             */
                            //Atribuindo peso ao naipe das cartas do jogador 1
                            if (jogadores.get(0).GetCarta().substring(1, 2).equals("o")) {
                                naipeJ1 = 0;
                            }

                            if (jogadores.get(0).GetCarta().substring(1, 2).equals("e")) {
                                naipeJ1 = 1;
                            }
                            if (jogadores.get(0).GetCarta().substring(1, 2).equals("c")) {
                                naipeJ1 = 2;
                            }

                            if (jogadores.get(0).GetCarta().substring(1, 2).equals("p")) {
                                naipeJ1 = 3;
                            }
                            if (jogadores.get(0).GetCarta().substring(1, 2).equals("o")) {
                                naipeJ1 = 0;
                            }

                            //Atribuindo peso ao naipe das cartas do jogador 2
                            if (jogadores.get(1).GetCarta().substring(1, 2).equals("o")) {
                                naipeJ2 = 0;
                            }

                            if (jogadores.get(1).GetCarta().substring(1, 2).equals("e")) {
                                naipeJ2 = 1;
                            }
                            if (jogadores.get(1).GetCarta().substring(1, 2).equals("c")) {
                                naipeJ2 = 2;
                            }

                            if (jogadores.get(1).GetCarta().substring(1, 2).equals("p")) {
                                naipeJ2 = 3;
                            }
                            if (jogadores.get(1).GetCarta().substring(1, 2).equals("o")) {
                                naipeJ2 = 0;
                            }

                            //Definindo CartaVirada
                            if (servidor.manilha.substring(0, 1).equals("q")) {
                                cartVirada = 10;
                            }

                            if (servidor.manilha.substring(0, 1).equals("j")) {
                                cartVirada = 11;
                            }

                            if (servidor.manilha.substring(0, 1).equals("k")) {
                                cartVirada = 12;
                            }
                            if (!servidor.manilha.substring(0, 1).equals("q") && !servidor.manilha.substring(0, 1).equals("j") && !servidor.manilha.substring(0, 1).equals("k")) {

                                cartVirada = Integer.parseInt(servidor.manilha.substring(0, 1));
                            }



                            if (cartVirada == 12) {
                                m = 1;
                            }

                            if (cartVirada == 7) {
                                m = 10;
                            }

                            if (cartVirada != 12 && cartVirada != 7) {

                                m = cartVirada + 1;
                            }
                            //Verificando se os dois jogadore tem a manilha
                           /* if (j1 == m && j2 == m) {
                            //Verifica quem tem o naipe maior
                            if (naipeJ1 > naipeJ2) {
                            vencedor = true;
                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                            servidor.CartaJogadorAtual = "null";
                            jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            
                            } else {
                            if (naipeJ2 > naipeJ1) {
                            vencedor = true;
                            servidor.jogadorAtual = jogadores.get(1).getSaida();
                            servidor.CartaJogadorAtual = "null";
                            jogadores.get(1).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(0).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            }
                            }
                            }
                            
                            //Verificando se somente o jogador 1 tem a manilha
                            if (j1 == m) {
                            if (!vencedor) {
                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                            servidor.CartaJogadorAtual = "null";
                            //if(servidor.rodadaAtual == 3){
                            jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            }
                            }
                            
                            //Verificando se somente o jogador 2 tem a manilha
                            if (j2 == m) {
                            if (!vencedor) {
                            servidor.jogadorAtual = jogadores.get(1).getSaida();
                            servidor.CartaJogadorAtual = "null";
                            jogadores.get(1).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(0).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            }
                            }
                            
                            //Verificando Empate da jogada
                            if (j1 == j2 && (j1 != m) && (j2 != m)) {
                            //Enviamensagem de empate
                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                            servidor.CartaJogadorAtual = "null";
                            jogadores.get(0).getSaida().writeObject(new Mensagem("601", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(1).getSaida().writeObject(new Mensagem("601", Integer.toString(servidor.PontosRodadaAtual)));
                            }   
                             */


                            //Verifica as condições em que J1 vence de J2
                            if (j1 == 3) {// Verifica se j1 jogou a carta 3






                                if (servidor.JogadaDecidida == false) {
                                    servidor.jogadorAtual = jogadores.get(0).getSaida();
                                    servidor.CartaJogadorAtual = "null";
                                    servidor.JogadaDecidida = true;
                                    jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                }

                                if (servidor.JogadaDecidida == true) {
                                    jogadores.get(0).SetCarta("null");
                                    jogadores.get(1).SetCarta("null");
                                    jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                }
                                //servidor.rodadaAtual++;                            

                            } else {
                                //Verifica se j1 jogou a carta 2 e j2 não jogou a 3
                                if (j1 == 2 && (j2 != 3)) {
                                    if (servidor.JogadaDecidida == false) {
                                        servidor.jogadorAtual = jogadores.get(0).getSaida();
                                        servidor.CartaJogadorAtual = "null";
                                        servidor.JogadaDecidida = true;
                                        jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                    }

                                    if (servidor.JogadaDecidida == true) {
                                        jogadores.get(0).SetCarta("null");
                                        jogadores.get(1).SetCarta("null");
                                        jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                    }
                                } else {
                                    //Verifica se j1 jogou a carta 2 e j2 não jogou a carta 3 ou a carta 2
                                    if ((j1 == 1) && (j2 != 2) || (j2 != 3)) { //verificar aqui

                                        if (servidor.JogadaDecidida == false) {
                                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                                            servidor.CartaJogadorAtual = "null";
                                            servidor.JogadaDecidida = true;
                                            jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                        }

                                        if (servidor.JogadaDecidida == true) {
                                            jogadores.get(0).SetCarta("null");
                                            jogadores.get(1).SetCarta("null");
                                            jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                        }

                                    } else {

                                        // Se j1 ou j2 não jogaram as cartas 3,2 ou 1 compara qual é a maior dentre as restante(4,5,6,10,11,12)
                                        if (j1 > j2) {
                                            if (servidor.JogadaDecidida == false) {
                                                servidor.jogadorAtual = jogadores.get(0).getSaida();
                                                servidor.CartaJogadorAtual = "null";
                                                servidor.JogadaDecidida = true;
                                                jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                            }

                                            if (servidor.JogadaDecidida == true) {
                                                jogadores.get(0).SetCarta("null");
                                                jogadores.get(1).SetCarta("null");
                                                jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                            }

                                        }

                                    }
                                }
                            }

                            //Verifica as condições em que j2 ganha de j1
                            if (j2 == 3) {// Verifica se j1 jogou a carta 3

                                if (servidor.JogadaDecidida == false) {
                                    servidor.jogadorAtual = jogadores.get(0).getSaida();
                                    servidor.CartaJogadorAtual = "null";
                                    servidor.JogadaDecidida = true;
                                    jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                }

                                if (servidor.JogadaDecidida == true) {
                                    jogadores.get(0).SetCarta("null");
                                    jogadores.get(1).SetCarta("null");
                                    jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                }

                            } else {
                                //Verifica se j1 jogou a carta 2 e j2 não jogou a 3
                                if (j2 == 2 && (j1 != 3)) {

                                    if (servidor.JogadaDecidida == false) {
                                        servidor.jogadorAtual = jogadores.get(0).getSaida();
                                        servidor.CartaJogadorAtual = "null";
                                        servidor.JogadaDecidida = true;
                                        jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                    }

                                    if (servidor.JogadaDecidida == true) {
                                        jogadores.get(0).SetCarta("null");
                                        jogadores.get(1).SetCarta("null");
                                        jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                    }
                                } else {
                                    //Verifica se j1 jogou a carta 2 e j2 não jogou a carta 3 ou a carta 2
                                    if (j2 == 1 && (j1 != 2) || (j1 != 3)) {

                                        if (servidor.JogadaDecidida == false) {
                                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                                            servidor.CartaJogadorAtual = "null";
                                            servidor.JogadaDecidida = true;
                                            jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                        }

                                        if (servidor.JogadaDecidida == true) {
                                            jogadores.get(0).SetCarta("null");
                                            jogadores.get(1).SetCarta("null");
                                            jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                        }
                                    } else {

                                        // Se j1 ou j2 não jogaram as cartas 3,2 ou 1 compara qual é a maior dentre as restante(4,5,6,10,11,12)
                                        if (j2 > j1) {

                                            if (servidor.JogadaDecidida == false) {
                                                servidor.jogadorAtual = jogadores.get(0).getSaida();
                                                servidor.CartaJogadorAtual = "null";
                                                servidor.JogadaDecidida = true;
                                                jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                                            }

                                            if (servidor.JogadaDecidida == true) {
                                                jogadores.get(0).SetCarta("null");
                                                jogadores.get(1).SetCarta("null");
                                                jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                                            }
                                        }

                                    }
                                }
                            }

                            /*
                            //Verifica se o jogador 1  jogou alguma carta entre 1 e 3 e é maior que jogador 2
                            if (j1 > j2 && (j1 != 4) && (j1 != 5) && (j1 != 6) && (j1 != 7) && (j1 != 10) && (j1 != 11) && (j1 != 12)) {
                            servidor.jogadorAtual = jogadores.get(0).getSaida();
                            
                            servidor.CartaJogadorAtual = "null";
                            
                            jogadores.get(0).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(0).SetCarta("null");
                            
                            jogadores.get(1).SetCarta("null");
                            jogadores.get(1).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            
                            
                            //servidor.rodadaAtual++;
                            
                            
                            } else {
                            //Verifica se o jogador 2 jogou alguma carta entre 1 e 3
                            if (j2 > j1 && (j2 != 4) && (j2 != 5) && (j2 != 6) && (j2 != 7) && (j2 != 10) && (j2 != 11) && (j2 != 12 )) {
                            
                            servidor.jogadorAtual = jogadores.get(1).getSaida();
                            
                            servidor.CartaJogadorAtual = "null";
                            
                            jogadores.get(1).getSaida().writeObject(new Mensagem("600", Integer.toString(servidor.PontosRodadaAtual)));
                            jogadores.get(1).SetCarta("null");
                            jogadores.get(0).SetCarta("null");
                            jogadores.get(0).getSaida().writeObject(new Mensagem("602", Integer.toString(servidor.PontosRodadaAtual)));
                            
                            
                            
                            }
                            }
                             */

                        }
                        break;


                    case 501: //truco aceito

                        //JOptionPane.showMessageDialog(pai,"COD: "+cod);
                        break;
                    case 502:   //fugir do truco

                        break;
                    case 301: //resultado da mão

                        break;
                    case 401:  //resultado da partida

                        break;
                    case 600: //Mão de 11

                        break;


                }

            }
            // fechando os fluxos e a conexao
            saida.close();
            entrada.close();
            conexao.close();
        } catch (Exception ex) {
            //System.err.println("Erro sockets: " + ex.toString());
            ex.printStackTrace();
        }







    }
}
